#!/bin/csh -f
#unlimit
limit coredumpsize 0
set working_directory	= `pwd`
set SCRATCH		= `grep scratch_dir mparameters | awk '{print $2}'`
if ( $status || $SCRATCH == "" ) then
  set SCRATCH		= ${working_directory}/scratch
endif
if ( ! -d $SCRATCH ) then
  mkdir $SCRATCH
endif
cd $SCRATCH

set bin_dir		= `grep frealign_bin_dir mparameters_run | awk '{print $2}'`
if ( $status || $bin_dir == "" ) then
  set bin_dir		= `which frealign_v9.exe`
  set bin_dir		= ${bin_dir:h}
endif
#
set start = $3
set data_input	= `grep data_input mparameters_run | awk '{print $2}'`
set raw_images	= `grep raw_images_high mparameters_run | awk '{print $2}'`
if ( $raw_images == "" ) set raw_images = `grep raw_images mparameters_run | awk '{print $2}'`
set raw_images	= `echo ${raw_images:r}`
set extension	= `ls $raw_images.* | head -1`
if ( $extension == "" ) then
  set raw_images = ${working_directory}/${raw_images}
  set extension	= `ls $raw_images.* | head -1`
endif
set extension	= `echo ${extension:e}`
set target	= `grep thresh_refine mparameters_run | awk '{print $2}'`
set pbc		= `grep PBC mparameters_run | awk '{print $2}'`
# set boff	= `grep BOFF mparameters_run | awk '{print $2}'`
set dang	= `grep DANG mparameters_run | awk '{print $2}'`
set itmax	= `grep ITMAX mparameters_run | awk '{print $2}'`
set mode	= `grep MODE mparameters_run | awk '{print $2}'`
set FPART	= `grep FPART mparameters_run | awk '{print $2}'`
set FMATCH	= `grep FMATCH mparameters_run | awk '{print $2}'`
set FBOOST	= `grep FBOOST mparameters_run | awk '{print $2}'`
set rrec	= `grep res_high_refinement mparameters_run | awk '{print $2}'`
set rref	= `grep res_search mparameters_run | awk '{print $2}'`
set rclas	= `grep res_high_class mparameters_run | awk '{print $2}'`
set rlowref	= `grep res_low_refinement mparameters_run | awk '{print $2}'`
set rbf		= `grep Bsearch mparameters_run | awk '{print $2}'`
set sym		= `grep Symmetry mparameters_run | awk '{print $2}'`
set pix		= `grep pix_size mparameters_run | awk '{print $2}'`
set kV		= `grep Voltage mparameters_run | awk '{print $2}'`
set AmpC	= `grep Amp_contrast mparameters_run | awk '{print $2}'`
set XSTD	= `grep XSTD mparameters_run | awk '{print $2}'`
set dstep	= `grep dstep mparameters_run | awk '{print $2}'`
set ro		= `grep outer_radius mparameters_run | awk '{print $2}'`
set ri		= `grep inner_radius mparameters_run | awk '{print $2}'`
set MW		= `grep mol_mass mparameters_run | awk '{print $2}'`
set cs		= `grep Aberration mparameters_run | awk '{print $2}'`
set mode	= ${5}
set psi		= ${6}
set theta	= ${7}
set phi		= ${8}
set shx		= ${9}
set shy		= ${10}
#
set form = `${bin_dir}/fheader.exe ${raw_images}.${extension} | grep --binary-files=text Opening | awk '{print $2}'`
set fm = "M"
if ( $form == "SPIDER" ) set fm = "S"
if ( $form == "IMAGIC" ) set fm = "I"
#
set imem = 3
set nx = `${bin_dir}/fheader.exe ${raw_images}.${extension} | grep --binary-files=text NX | awk '{print $4}'`
if ($nx > 300) set imem = 0

if (${mode} == "") set mode = 1

### check for shift & angle refinement
if (${psi} == "") set psi = 1
if (${theta} == "") set theta = 1
if (${phi} == "") set phi = 1
if (${shx} == "") set shx = 1
if (${shy} == "") set shy = 1

set ifsc = 0
if ( $FBOOST == "T" ) set ifsc = -1

@ prev = $start - 1
#
\rm ${data_input}_${start}_r${4}.par_${1}_${2} >& /dev/null
#
time ${bin_dir}/frealign_v9.exe << eot >& ${data_input}_mult_refine_n_r${4}.log_${1}_${2}
${fm},${mode},F,F,F,${FPART},0,F,F,F,T,${ifsc},F,${imem},1			!CFORM,IFLAG,FMAG,FDEF,FASTIG,FPART,IEWALD,FBEAUT,FFILT,FBFACT,FMATCH,IFSC,FDUMP,IMEM,INTERP
${ro},${ri},${pix},${MW},${AmpC},${XSTD},${pbc},0.0,${dang},${itmax},20	!RO,RI,PSIZE,WGH,XSTD,PBC,BOFF,DANG,ITMAX,IPMAX
${psi},${theta},${phi},${shx},${shy}					!MASK
${1},${2}								!IFIRST,ILAST
${sym}									!ASYM symmetry card (I=icosahedral)
1.0,${dstep},${target},0.0,${cs},${kV},0.0,0.0				!RELMAG,DSTEP,TARGET,THRESH,CS,AKV,TX,TY
${rrec},   ${rlowref},   ${rref}, ${rclas}, 100.0, ${rbf}		!RREC,RMIN,RMAX,RCLAS,DFSTD,RBFACT
${raw_images}.${extension}
${data_input}_reproject_r${4}.${extension}_${1}_${2}
${working_directory}/${data_input}_${prev}_r${4}.par
${data_input}_${start}_r${4}.par_${1}_${2}
${data_input}_${start}_r${4}.shft_${1}_${2}
-100., 0., 0., 0., 0., 0., 0., 0.					! terminator with RELMAG=0.0
${working_directory}/${data_input}_${prev}_r${4}.${extension}
${data_input}_${start}_r${4}_weights
${data_input}_${start}_r${4}_map1.${extension}
${data_input}_${start}_r${4}_map2.${extension}
${data_input}_${start}_r${4}_phasediffs
${data_input}_${start}_r${4}_pointspread
eot
#
echo Job on $HOST finished >> stderr
#
