C*
C* Copyright 2013 Howard Hughes Medical Institute.
C* All rights reserved.
C* Use is subject to Janelia Farm Research Campus Software Copyright 1.1
C* license terms ( http://license.janelia.org/license/jfrc_copyright_1_1.html )
C*
C**************************************************************************
      SUBROUTINE PWEIGHT(NSAM,SPEC,SPEQ,OUTC,OUTQ,
     +          SSNR,CTFF,CTFS,PWEIGHTS,RBUF,ICTF)
C**************************************************************************
C  Applies SNR weighting to input 2D image
C  Used in CTFAPPLY
C**************************************************************************
      IMPLICIT NONE
C
      INTEGER NSAM,JC,I,J,II,JJ,IRAD,NSAMH,ICTF
      INTEGER MAXR12,MAXR22,ITEMP,IBIN,IC,ID
      REAL SSNR(*),SNR,WGT,PWEIGHTS(*),RBUF(*)
      COMPLEX SAMP,SPEC(*),SPEQ(*),OUTC(*),OUTQ(*)
      COMPLEX CTFF(*),CTFS(*),CTFR,CTFL,Z
C**************************************************************************
      JC=NSAM/2+1
      IC=NSAM*NSAM/2
      NSAMH=NSAM/2
      MAXR12=0
      MAXR22=JC**2
C
      DO 50 I=1,JC
        PWEIGHTS(I)=0.0
50    CONTINUE
C
      DO 10 I=1,2*JC
        RBUF(I)=0.0
10    CONTINUE
C
      DO 20 I=0,JC-1
        II=I+1
        DO 20 J=-JC+1,JC-1
          ITEMP=I**2+J**2
          IF ((ITEMP.GE.MAXR12).AND.(ITEMP.LT.MAXR22)) THEN
            IBIN=INT(SQRT(FLOAT(ITEMP))+0.5)+1
            JJ=J+1
            IF (JJ.LT.1) JJ=JJ+NSAM
            IF (II.NE.JC) THEN
              ID=II+NSAMH*(JJ-1)
              Z=SPEC(ID)
            ELSE
              Z=SPEQ(JJ)
            ENDIF
            RBUF(IBIN)=RBUF(IBIN)+CABS(Z)**2
            RBUF(IBIN+JC)=RBUF(IBIN+JC)+1.0
          ENDIF
20    CONTINUE
C
      DO 60 I=1,JC
        IF (RBUF(I+JC).NE.0.0) RBUF(I)=SQRT(RBUF(I)/RBUF(I+JC))
        IF (RBUF(I).EQ.0.0) RBUF(I)=1.0
60    CONTINUE
C
      DO 30 I=0,JC-1
      	II=I+1
      	DO 30 J=-JC+1,JC-1
      	  ITEMP=I**2+J**2
          IF ((ITEMP.GE.MAXR12).AND.(ITEMP.LT.MAXR22)) THEN
            IBIN=INT(SQRT(FLOAT(ITEMP))+0.5)+1
      	    JJ=J+1
      	    IF (JJ.LT.1) JJ=JJ+NSAM
      	    IF (II.NE.JC) THEN
      	      ID=II+NSAMH*(JJ-1)
              IF (ICTF.EQ.1) THEN
       	        CTFR=CTFF(ID)
      	        CTFL=CTFF(ID+IC)
                SNR=SSNR(IBIN)*CABS(CTFR+CONJG(CTFL))**2
              ELSE
                SNR=SSNR(IBIN)
              ENDIF
              WGT=SNR/(SNR+1.0)/RBUF(IBIN)
              Z=SPEC(ID)*WGT
              OUTC(ID)=Z
              IF (ICTF.EQ.1) THEN
                SNR=SSNR(IBIN)*CABS(CTFR+CONJG(CTFL))**2
              ELSE
                SNR=SSNR(IBIN)
              ENDIF
              WGT=SNR/(SNR+1.0)
              PWEIGHTS(IBIN)=PWEIGHTS(IBIN)+WGT
      	    ELSE
              IF (ICTF.EQ.1) THEN
      	        CTFR=CTFS(JJ)
      	        CTFL=CTFS(JJ+NSAM)
                SNR=SSNR(IBIN)*CABS(CTFR+CONJG(CTFL))**2
              ELSE
                SNR=SSNR(IBIN)
              ENDIF
              WGT=SNR/(SNR+1.0)/RBUF(IBIN)
              Z=SPEQ(JJ)*WGT
              OUTQ(JJ)=Z
              IF (ICTF.EQ.1) THEN
                SNR=SSNR(IBIN)*CABS(CTFR+CONJG(CTFL))**2
              ELSE
                SNR=SSNR(IBIN)
              ENDIF
              WGT=SNR/(SNR+1.0)
              PWEIGHTS(IBIN)=PWEIGHTS(IBIN)+WGT
      	    ENDIF
      	  ELSEIF (ITEMP.GE.MAXR22) THEN
            IBIN=INT(SQRT(FLOAT(ITEMP))+0.5)+1
      	    JJ=J+1
      	    IF (JJ.LT.1) JJ=JJ+NSAM
      	    IF (II.NE.JC) THEN
      	      ID=II+NSAMH*(JJ-1)
              OUTC(ID)=CMPLX(0.0,0.0)
      	    ELSE
              OUTQ(JJ)=CMPLX(0.0,0.0)
      	    ENDIF
          ENDIF
30    CONTINUE
C
      DO 40 I=1,JC
        IF (RBUF(I+JC).NE.0.0) PWEIGHTS(I)=PWEIGHTS(I)/RBUF(I+JC)
40    CONTINUE
C
      RETURN
      END
